"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getModuleResolvePath = void 0;
const utils_1 = require("@vuepress/utils");
const enhanced_resolve_1 = __importDefault(require("enhanced-resolve"));
const slash2_1 = __importDefault(require("slash2"));
const DEFAULT_EXT = ['.tsx', '.jsx', '.js', '.ts', '.vue'];
function getModuleResolvePath({ basePath, sourcePath, extensions = DEFAULT_EXT, silent = null, }) {
    try {
        const absolutePath = enhanced_resolve_1.default.create.sync({
            extensions,
            symlinks: false,
            exportsFields: ['exports.import'],
            mainFiles: ['index', 'package.json'],
        })(utils_1.fs.statSync(basePath).isDirectory() ? basePath : utils_1.path.parse(basePath).dir, sourcePath);
        return (0, slash2_1.default)(absolutePath);
    }
    catch (err) {
        if (!silent) {
            console.error(`[vuepress]: cannot resolve module ${sourcePath} from ${basePath}`);
        }
        throw err;
    }
}
exports.getModuleResolvePath = getModuleResolvePath;
